package com.dhcc.finance.main.domain;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class CwHsSubcodemapExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public CwHsSubcodemapExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("ID is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("ID is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("ID =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("ID <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("ID >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("ID >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("ID <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("ID <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("ID like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("ID not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("ID in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("ID not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("ID between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("ID not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andBookCodeIsNull() {
            addCriterion("BOOK_CODE is null");
            return (Criteria) this;
        }

        public Criteria andBookCodeIsNotNull() {
            addCriterion("BOOK_CODE is not null");
            return (Criteria) this;
        }

        public Criteria andBookCodeEqualTo(Integer value) {
            addCriterion("BOOK_CODE =", value, "bookCode");
            return (Criteria) this;
        }

        public Criteria andBookCodeNotEqualTo(Integer value) {
            addCriterion("BOOK_CODE <>", value, "bookCode");
            return (Criteria) this;
        }

        public Criteria andBookCodeGreaterThan(Integer value) {
            addCriterion("BOOK_CODE >", value, "bookCode");
            return (Criteria) this;
        }

        public Criteria andBookCodeGreaterThanOrEqualTo(Integer value) {
            addCriterion("BOOK_CODE >=", value, "bookCode");
            return (Criteria) this;
        }

        public Criteria andBookCodeLessThan(Integer value) {
            addCriterion("BOOK_CODE <", value, "bookCode");
            return (Criteria) this;
        }

        public Criteria andBookCodeLessThanOrEqualTo(Integer value) {
            addCriterion("BOOK_CODE <=", value, "bookCode");
            return (Criteria) this;
        }

        public Criteria andBookCodeIn(List<Integer> values) {
            addCriterion("BOOK_CODE in", values, "bookCode");
            return (Criteria) this;
        }

        public Criteria andBookCodeNotIn(List<Integer> values) {
            addCriterion("BOOK_CODE not in", values, "bookCode");
            return (Criteria) this;
        }

        public Criteria andBookCodeBetween(Integer value1, Integer value2) {
            addCriterion("BOOK_CODE between", value1, value2, "bookCode");
            return (Criteria) this;
        }

        public Criteria andBookCodeNotBetween(Integer value1, Integer value2) {
            addCriterion("BOOK_CODE not between", value1, value2, "bookCode");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagIsNull() {
            addCriterion("COMPANY_FLAG is null");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagIsNotNull() {
            addCriterion("COMPANY_FLAG is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagEqualTo(String value) {
            addCriterion("COMPANY_FLAG =", value, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagNotEqualTo(String value) {
            addCriterion("COMPANY_FLAG <>", value, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagGreaterThan(String value) {
            addCriterion("COMPANY_FLAG >", value, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagGreaterThanOrEqualTo(String value) {
            addCriterion("COMPANY_FLAG >=", value, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagLessThan(String value) {
            addCriterion("COMPANY_FLAG <", value, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagLessThanOrEqualTo(String value) {
            addCriterion("COMPANY_FLAG <=", value, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagLike(String value) {
            addCriterion("COMPANY_FLAG like", value, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagNotLike(String value) {
            addCriterion("COMPANY_FLAG not like", value, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagIn(List<String> values) {
            addCriterion("COMPANY_FLAG in", values, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagNotIn(List<String> values) {
            addCriterion("COMPANY_FLAG not in", values, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagBetween(String value1, String value2) {
            addCriterion("COMPANY_FLAG between", value1, value2, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagNotBetween(String value1, String value2) {
            addCriterion("COMPANY_FLAG not between", value1, value2, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andImportFlagIsNull() {
            addCriterion("IMPORT_FLAG is null");
            return (Criteria) this;
        }

        public Criteria andImportFlagIsNotNull() {
            addCriterion("IMPORT_FLAG is not null");
            return (Criteria) this;
        }

        public Criteria andImportFlagEqualTo(String value) {
            addCriterion("IMPORT_FLAG =", value, "importFlag");
            return (Criteria) this;
        }

        public Criteria andImportFlagNotEqualTo(String value) {
            addCriterion("IMPORT_FLAG <>", value, "importFlag");
            return (Criteria) this;
        }

        public Criteria andImportFlagGreaterThan(String value) {
            addCriterion("IMPORT_FLAG >", value, "importFlag");
            return (Criteria) this;
        }

        public Criteria andImportFlagGreaterThanOrEqualTo(String value) {
            addCriterion("IMPORT_FLAG >=", value, "importFlag");
            return (Criteria) this;
        }

        public Criteria andImportFlagLessThan(String value) {
            addCriterion("IMPORT_FLAG <", value, "importFlag");
            return (Criteria) this;
        }

        public Criteria andImportFlagLessThanOrEqualTo(String value) {
            addCriterion("IMPORT_FLAG <=", value, "importFlag");
            return (Criteria) this;
        }

        public Criteria andImportFlagLike(String value) {
            addCriterion("IMPORT_FLAG like", value, "importFlag");
            return (Criteria) this;
        }

        public Criteria andImportFlagNotLike(String value) {
            addCriterion("IMPORT_FLAG not like", value, "importFlag");
            return (Criteria) this;
        }

        public Criteria andImportFlagIn(List<String> values) {
            addCriterion("IMPORT_FLAG in", values, "importFlag");
            return (Criteria) this;
        }

        public Criteria andImportFlagNotIn(List<String> values) {
            addCriterion("IMPORT_FLAG not in", values, "importFlag");
            return (Criteria) this;
        }

        public Criteria andImportFlagBetween(String value1, String value2) {
            addCriterion("IMPORT_FLAG between", value1, value2, "importFlag");
            return (Criteria) this;
        }

        public Criteria andImportFlagNotBetween(String value1, String value2) {
            addCriterion("IMPORT_FLAG not between", value1, value2, "importFlag");
            return (Criteria) this;
        }

        public Criteria andSubCodeIsNull() {
            addCriterion("SUB_CODE is null");
            return (Criteria) this;
        }

        public Criteria andSubCodeIsNotNull() {
            addCriterion("SUB_CODE is not null");
            return (Criteria) this;
        }

        public Criteria andSubCodeEqualTo(String value) {
            addCriterion("SUB_CODE =", value, "subCode");
            return (Criteria) this;
        }

        public Criteria andSubCodeNotEqualTo(String value) {
            addCriterion("SUB_CODE <>", value, "subCode");
            return (Criteria) this;
        }

        public Criteria andSubCodeGreaterThan(String value) {
            addCriterion("SUB_CODE >", value, "subCode");
            return (Criteria) this;
        }

        public Criteria andSubCodeGreaterThanOrEqualTo(String value) {
            addCriterion("SUB_CODE >=", value, "subCode");
            return (Criteria) this;
        }

        public Criteria andSubCodeLessThan(String value) {
            addCriterion("SUB_CODE <", value, "subCode");
            return (Criteria) this;
        }

        public Criteria andSubCodeLessThanOrEqualTo(String value) {
            addCriterion("SUB_CODE <=", value, "subCode");
            return (Criteria) this;
        }

        public Criteria andSubCodeLike(String value) {
            addCriterion("SUB_CODE like", value, "subCode");
            return (Criteria) this;
        }

        public Criteria andSubCodeNotLike(String value) {
            addCriterion("SUB_CODE not like", value, "subCode");
            return (Criteria) this;
        }

        public Criteria andSubCodeIn(List<String> values) {
            addCriterion("SUB_CODE in", values, "subCode");
            return (Criteria) this;
        }

        public Criteria andSubCodeNotIn(List<String> values) {
            addCriterion("SUB_CODE not in", values, "subCode");
            return (Criteria) this;
        }

        public Criteria andSubCodeBetween(String value1, String value2) {
            addCriterion("SUB_CODE between", value1, value2, "subCode");
            return (Criteria) this;
        }

        public Criteria andSubCodeNotBetween(String value1, String value2) {
            addCriterion("SUB_CODE not between", value1, value2, "subCode");
            return (Criteria) this;
        }

        public Criteria andSubNameIsNull() {
            addCriterion("SUB_NAME is null");
            return (Criteria) this;
        }

        public Criteria andSubNameIsNotNull() {
            addCriterion("SUB_NAME is not null");
            return (Criteria) this;
        }

        public Criteria andSubNameEqualTo(String value) {
            addCriterion("SUB_NAME =", value, "subName");
            return (Criteria) this;
        }

        public Criteria andSubNameNotEqualTo(String value) {
            addCriterion("SUB_NAME <>", value, "subName");
            return (Criteria) this;
        }

        public Criteria andSubNameGreaterThan(String value) {
            addCriterion("SUB_NAME >", value, "subName");
            return (Criteria) this;
        }

        public Criteria andSubNameGreaterThanOrEqualTo(String value) {
            addCriterion("SUB_NAME >=", value, "subName");
            return (Criteria) this;
        }

        public Criteria andSubNameLessThan(String value) {
            addCriterion("SUB_NAME <", value, "subName");
            return (Criteria) this;
        }

        public Criteria andSubNameLessThanOrEqualTo(String value) {
            addCriterion("SUB_NAME <=", value, "subName");
            return (Criteria) this;
        }

        public Criteria andSubNameLike(String value) {
            addCriterion("SUB_NAME like", value, "subName");
            return (Criteria) this;
        }

        public Criteria andSubNameNotLike(String value) {
            addCriterion("SUB_NAME not like", value, "subName");
            return (Criteria) this;
        }

        public Criteria andSubNameIn(List<String> values) {
            addCriterion("SUB_NAME in", values, "subName");
            return (Criteria) this;
        }

        public Criteria andSubNameNotIn(List<String> values) {
            addCriterion("SUB_NAME not in", values, "subName");
            return (Criteria) this;
        }

        public Criteria andSubNameBetween(String value1, String value2) {
            addCriterion("SUB_NAME between", value1, value2, "subName");
            return (Criteria) this;
        }

        public Criteria andSubNameNotBetween(String value1, String value2) {
            addCriterion("SUB_NAME not between", value1, value2, "subName");
            return (Criteria) this;
        }

        public Criteria andSeidIdIsNull() {
            addCriterion("SEID_ID is null");
            return (Criteria) this;
        }

        public Criteria andSeidIdIsNotNull() {
            addCriterion("SEID_ID is not null");
            return (Criteria) this;
        }

        public Criteria andSeidIdEqualTo(String value) {
            addCriterion("SEID_ID =", value, "seidId");
            return (Criteria) this;
        }

        public Criteria andSeidIdNotEqualTo(String value) {
            addCriterion("SEID_ID <>", value, "seidId");
            return (Criteria) this;
        }

        public Criteria andSeidIdGreaterThan(String value) {
            addCriterion("SEID_ID >", value, "seidId");
            return (Criteria) this;
        }

        public Criteria andSeidIdGreaterThanOrEqualTo(String value) {
            addCriterion("SEID_ID >=", value, "seidId");
            return (Criteria) this;
        }

        public Criteria andSeidIdLessThan(String value) {
            addCriterion("SEID_ID <", value, "seidId");
            return (Criteria) this;
        }

        public Criteria andSeidIdLessThanOrEqualTo(String value) {
            addCriterion("SEID_ID <=", value, "seidId");
            return (Criteria) this;
        }

        public Criteria andSeidIdLike(String value) {
            addCriterion("SEID_ID like", value, "seidId");
            return (Criteria) this;
        }

        public Criteria andSeidIdNotLike(String value) {
            addCriterion("SEID_ID not like", value, "seidId");
            return (Criteria) this;
        }

        public Criteria andSeidIdIn(List<String> values) {
            addCriterion("SEID_ID in", values, "seidId");
            return (Criteria) this;
        }

        public Criteria andSeidIdNotIn(List<String> values) {
            addCriterion("SEID_ID not in", values, "seidId");
            return (Criteria) this;
        }

        public Criteria andSeidIdBetween(String value1, String value2) {
            addCriterion("SEID_ID between", value1, value2, "seidId");
            return (Criteria) this;
        }

        public Criteria andSeidIdNotBetween(String value1, String value2) {
            addCriterion("SEID_ID not between", value1, value2, "seidId");
            return (Criteria) this;
        }

        public Criteria andStockTypeIsNull() {
            addCriterion("STOCK_TYPE is null");
            return (Criteria) this;
        }

        public Criteria andStockTypeIsNotNull() {
            addCriterion("STOCK_TYPE is not null");
            return (Criteria) this;
        }

        public Criteria andStockTypeEqualTo(String value) {
            addCriterion("STOCK_TYPE =", value, "stockType");
            return (Criteria) this;
        }

        public Criteria andStockTypeNotEqualTo(String value) {
            addCriterion("STOCK_TYPE <>", value, "stockType");
            return (Criteria) this;
        }

        public Criteria andStockTypeGreaterThan(String value) {
            addCriterion("STOCK_TYPE >", value, "stockType");
            return (Criteria) this;
        }

        public Criteria andStockTypeGreaterThanOrEqualTo(String value) {
            addCriterion("STOCK_TYPE >=", value, "stockType");
            return (Criteria) this;
        }

        public Criteria andStockTypeLessThan(String value) {
            addCriterion("STOCK_TYPE <", value, "stockType");
            return (Criteria) this;
        }

        public Criteria andStockTypeLessThanOrEqualTo(String value) {
            addCriterion("STOCK_TYPE <=", value, "stockType");
            return (Criteria) this;
        }

        public Criteria andStockTypeLike(String value) {
            addCriterion("STOCK_TYPE like", value, "stockType");
            return (Criteria) this;
        }

        public Criteria andStockTypeNotLike(String value) {
            addCriterion("STOCK_TYPE not like", value, "stockType");
            return (Criteria) this;
        }

        public Criteria andStockTypeIn(List<String> values) {
            addCriterion("STOCK_TYPE in", values, "stockType");
            return (Criteria) this;
        }

        public Criteria andStockTypeNotIn(List<String> values) {
            addCriterion("STOCK_TYPE not in", values, "stockType");
            return (Criteria) this;
        }

        public Criteria andStockTypeBetween(String value1, String value2) {
            addCriterion("STOCK_TYPE between", value1, value2, "stockType");
            return (Criteria) this;
        }

        public Criteria andStockTypeNotBetween(String value1, String value2) {
            addCriterion("STOCK_TYPE not between", value1, value2, "stockType");
            return (Criteria) this;
        }

        public Criteria andSubCodeVIsNull() {
            addCriterion("SUB_CODE_V is null");
            return (Criteria) this;
        }

        public Criteria andSubCodeVIsNotNull() {
            addCriterion("SUB_CODE_V is not null");
            return (Criteria) this;
        }

        public Criteria andSubCodeVEqualTo(String value) {
            addCriterion("SUB_CODE_V =", value, "subCodeV");
            return (Criteria) this;
        }

        public Criteria andSubCodeVNotEqualTo(String value) {
            addCriterion("SUB_CODE_V <>", value, "subCodeV");
            return (Criteria) this;
        }

        public Criteria andSubCodeVGreaterThan(String value) {
            addCriterion("SUB_CODE_V >", value, "subCodeV");
            return (Criteria) this;
        }

        public Criteria andSubCodeVGreaterThanOrEqualTo(String value) {
            addCriterion("SUB_CODE_V >=", value, "subCodeV");
            return (Criteria) this;
        }

        public Criteria andSubCodeVLessThan(String value) {
            addCriterion("SUB_CODE_V <", value, "subCodeV");
            return (Criteria) this;
        }

        public Criteria andSubCodeVLessThanOrEqualTo(String value) {
            addCriterion("SUB_CODE_V <=", value, "subCodeV");
            return (Criteria) this;
        }

        public Criteria andSubCodeVLike(String value) {
            addCriterion("SUB_CODE_V like", value, "subCodeV");
            return (Criteria) this;
        }

        public Criteria andSubCodeVNotLike(String value) {
            addCriterion("SUB_CODE_V not like", value, "subCodeV");
            return (Criteria) this;
        }

        public Criteria andSubCodeVIn(List<String> values) {
            addCriterion("SUB_CODE_V in", values, "subCodeV");
            return (Criteria) this;
        }

        public Criteria andSubCodeVNotIn(List<String> values) {
            addCriterion("SUB_CODE_V not in", values, "subCodeV");
            return (Criteria) this;
        }

        public Criteria andSubCodeVBetween(String value1, String value2) {
            addCriterion("SUB_CODE_V between", value1, value2, "subCodeV");
            return (Criteria) this;
        }

        public Criteria andSubCodeVNotBetween(String value1, String value2) {
            addCriterion("SUB_CODE_V not between", value1, value2, "subCodeV");
            return (Criteria) this;
        }

        public Criteria andSubNameVIsNull() {
            addCriterion("SUB_NAME_V is null");
            return (Criteria) this;
        }

        public Criteria andSubNameVIsNotNull() {
            addCriterion("SUB_NAME_V is not null");
            return (Criteria) this;
        }

        public Criteria andSubNameVEqualTo(String value) {
            addCriterion("SUB_NAME_V =", value, "subNameV");
            return (Criteria) this;
        }

        public Criteria andSubNameVNotEqualTo(String value) {
            addCriterion("SUB_NAME_V <>", value, "subNameV");
            return (Criteria) this;
        }

        public Criteria andSubNameVGreaterThan(String value) {
            addCriterion("SUB_NAME_V >", value, "subNameV");
            return (Criteria) this;
        }

        public Criteria andSubNameVGreaterThanOrEqualTo(String value) {
            addCriterion("SUB_NAME_V >=", value, "subNameV");
            return (Criteria) this;
        }

        public Criteria andSubNameVLessThan(String value) {
            addCriterion("SUB_NAME_V <", value, "subNameV");
            return (Criteria) this;
        }

        public Criteria andSubNameVLessThanOrEqualTo(String value) {
            addCriterion("SUB_NAME_V <=", value, "subNameV");
            return (Criteria) this;
        }

        public Criteria andSubNameVLike(String value) {
            addCriterion("SUB_NAME_V like", value, "subNameV");
            return (Criteria) this;
        }

        public Criteria andSubNameVNotLike(String value) {
            addCriterion("SUB_NAME_V not like", value, "subNameV");
            return (Criteria) this;
        }

        public Criteria andSubNameVIn(List<String> values) {
            addCriterion("SUB_NAME_V in", values, "subNameV");
            return (Criteria) this;
        }

        public Criteria andSubNameVNotIn(List<String> values) {
            addCriterion("SUB_NAME_V not in", values, "subNameV");
            return (Criteria) this;
        }

        public Criteria andSubNameVBetween(String value1, String value2) {
            addCriterion("SUB_NAME_V between", value1, value2, "subNameV");
            return (Criteria) this;
        }

        public Criteria andSubNameVNotBetween(String value1, String value2) {
            addCriterion("SUB_NAME_V not between", value1, value2, "subNameV");
            return (Criteria) this;
        }

        public Criteria andProductIdIsNull() {
            addCriterion("PRODUCT_ID is null");
            return (Criteria) this;
        }

        public Criteria andProductIdIsNotNull() {
            addCriterion("PRODUCT_ID is not null");
            return (Criteria) this;
        }

        public Criteria andProductIdEqualTo(String value) {
            addCriterion("PRODUCT_ID =", value, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdNotEqualTo(String value) {
            addCriterion("PRODUCT_ID <>", value, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdGreaterThan(String value) {
            addCriterion("PRODUCT_ID >", value, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdGreaterThanOrEqualTo(String value) {
            addCriterion("PRODUCT_ID >=", value, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdLessThan(String value) {
            addCriterion("PRODUCT_ID <", value, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdLessThanOrEqualTo(String value) {
            addCriterion("PRODUCT_ID <=", value, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdLike(String value) {
            addCriterion("PRODUCT_ID like", value, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdNotLike(String value) {
            addCriterion("PRODUCT_ID not like", value, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdIn(List<String> values) {
            addCriterion("PRODUCT_ID in", values, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdNotIn(List<String> values) {
            addCriterion("PRODUCT_ID not in", values, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdBetween(String value1, String value2) {
            addCriterion("PRODUCT_ID between", value1, value2, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdNotBetween(String value1, String value2) {
            addCriterion("PRODUCT_ID not between", value1, value2, "productId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdIsNull() {
            addCriterion("SUB_PRODUCT_ID is null");
            return (Criteria) this;
        }

        public Criteria andSubProductIdIsNotNull() {
            addCriterion("SUB_PRODUCT_ID is not null");
            return (Criteria) this;
        }

        public Criteria andSubProductIdEqualTo(String value) {
            addCriterion("SUB_PRODUCT_ID =", value, "subProductId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdNotEqualTo(String value) {
            addCriterion("SUB_PRODUCT_ID <>", value, "subProductId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdGreaterThan(String value) {
            addCriterion("SUB_PRODUCT_ID >", value, "subProductId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdGreaterThanOrEqualTo(String value) {
            addCriterion("SUB_PRODUCT_ID >=", value, "subProductId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdLessThan(String value) {
            addCriterion("SUB_PRODUCT_ID <", value, "subProductId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdLessThanOrEqualTo(String value) {
            addCriterion("SUB_PRODUCT_ID <=", value, "subProductId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdLike(String value) {
            addCriterion("SUB_PRODUCT_ID like", value, "subProductId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdNotLike(String value) {
            addCriterion("SUB_PRODUCT_ID not like", value, "subProductId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdIn(List<String> values) {
            addCriterion("SUB_PRODUCT_ID in", values, "subProductId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdNotIn(List<String> values) {
            addCriterion("SUB_PRODUCT_ID not in", values, "subProductId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdBetween(String value1, String value2) {
            addCriterion("SUB_PRODUCT_ID between", value1, value2, "subProductId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdNotBetween(String value1, String value2) {
            addCriterion("SUB_PRODUCT_ID not between", value1, value2, "subProductId");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNull() {
            addCriterion("USE_STATE is null");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNotNull() {
            addCriterion("USE_STATE is not null");
            return (Criteria) this;
        }

        public Criteria andUseStateEqualTo(String value) {
            addCriterion("USE_STATE =", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotEqualTo(String value) {
            addCriterion("USE_STATE <>", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThan(String value) {
            addCriterion("USE_STATE >", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThanOrEqualTo(String value) {
            addCriterion("USE_STATE >=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThan(String value) {
            addCriterion("USE_STATE <", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThanOrEqualTo(String value) {
            addCriterion("USE_STATE <=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLike(String value) {
            addCriterion("USE_STATE like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotLike(String value) {
            addCriterion("USE_STATE not like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateIn(List<String> values) {
            addCriterion("USE_STATE in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotIn(List<String> values) {
            addCriterion("USE_STATE not in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateBetween(String value1, String value2) {
            addCriterion("USE_STATE between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotBetween(String value1, String value2) {
            addCriterion("USE_STATE not between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNull() {
            addCriterion("CREATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNotNull() {
            addCriterion("CREATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserEqualTo(String value) {
            addCriterion("CREATE_USER =", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotEqualTo(String value) {
            addCriterion("CREATE_USER <>", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThan(String value) {
            addCriterion("CREATE_USER >", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThanOrEqualTo(String value) {
            addCriterion("CREATE_USER >=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThan(String value) {
            addCriterion("CREATE_USER <", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThanOrEqualTo(String value) {
            addCriterion("CREATE_USER <=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLike(String value) {
            addCriterion("CREATE_USER like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotLike(String value) {
            addCriterion("CREATE_USER not like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserIn(List<String> values) {
            addCriterion("CREATE_USER in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotIn(List<String> values) {
            addCriterion("CREATE_USER not in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserBetween(String value1, String value2) {
            addCriterion("CREATE_USER between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotBetween(String value1, String value2) {
            addCriterion("CREATE_USER not between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("CREATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("CREATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("CREATE_TIME =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("CREATE_TIME <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("CREATE_TIME >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("CREATE_TIME <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("CREATE_TIME in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("CREATE_TIME not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNull() {
            addCriterion("UPDATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNotNull() {
            addCriterion("UPDATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserEqualTo(String value) {
            addCriterion("UPDATE_USER =", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotEqualTo(String value) {
            addCriterion("UPDATE_USER <>", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThan(String value) {
            addCriterion("UPDATE_USER >", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER >=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThan(String value) {
            addCriterion("UPDATE_USER <", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER <=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLike(String value) {
            addCriterion("UPDATE_USER like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotLike(String value) {
            addCriterion("UPDATE_USER not like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIn(List<String> values) {
            addCriterion("UPDATE_USER in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotIn(List<String> values) {
            addCriterion("UPDATE_USER not in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserBetween(String value1, String value2) {
            addCriterion("UPDATE_USER between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotBetween(String value1, String value2) {
            addCriterion("UPDATE_USER not between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("UPDATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("UPDATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("UPDATE_TIME =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("UPDATE_TIME <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("UPDATE_TIME >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("UPDATE_TIME <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("UPDATE_TIME in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("UPDATE_TIME not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("REMARK is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("REMARK is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("REMARK =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("REMARK <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("REMARK >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("REMARK >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("REMARK <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("REMARK <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("REMARK like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("REMARK not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("REMARK in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("REMARK not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("REMARK between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("REMARK not between", value1, value2, "remark");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}